import { WebContents, IpcRenderer, IpcMain, IpcMainEvent, IpcRendererEvent } from 'electron';
import { AbstractHub, IResponse, IRequest, IProgress } from 'duplex-message';
export interface IElectronMessageHubOptions {
    /** ipc channel name used under the hood, default: message-hub */
    channelName?: string;
}
export declare abstract class ElectronMessageHub extends AbstractHub {
    protected readonly _channelName: string;
    protected abstract readonly _ipc: IpcMain | IpcRenderer;
    constructor(options?: IElectronMessageHubOptions);
    protected sendMessage(target: WebContents | IpcRenderer, msg: IRequest | IResponse | IProgress): void;
    protected _onMessageReceived(evt: IpcMainEvent | IpcRendererEvent, msg: any): Promise<void>;
}
