"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElectronMessageHub = void 0;
const duplex_message_1 = require("duplex-message");
class ElectronMessageHub extends duplex_message_1.AbstractHub {
    constructor(options) {
        super();
        // eslint-disable-next-line no-param-reassign
        options = Object.assign({ channelName: 'message-hub' }, options);
        this._channelName = options.channelName;
        this._onMessageReceived = this._onMessageReceived.bind(this);
    }
    sendMessage(target, msg) {
        target.send(this._channelName, msg);
    }
    async _onMessageReceived(evt, msg) {
        this._onMessage(evt.sender, msg);
    }
}
exports.ElectronMessageHub = ElectronMessageHub;
