"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainMessageHub = void 0;
const electron_1 = __importDefault(require("electron"));
const abstract_1 = require("./abstract");
let sharedMainMessageHub;
class MainMessageHub extends abstract_1.ElectronMessageHub {
    constructor(options) {
        if (process.type !== 'browser') {
            throw new TypeError('MainMessageHub only available in electron main process');
        }
        super(options);
        this._ipc = electron_1.default.ipcMain;
        this._ipc.on(this._channelName, this._onMessageReceived);
    }
    emit(target, method, ...args) {
        return super._emit(target, method, ...args);
    }
    on(target, handlerMap, handler) {
        // @ts-ignore
        this._on(target, handlerMap, handler);
    }
    off(target, methodName) {
        this._off(target, methodName);
    }
    /** shared MainMessageHub instance */
    static get shared() {
        if (!sharedMainMessageHub) {
            sharedMainMessageHub = new MainMessageHub();
        }
        return sharedMainMessageHub;
    }
}
exports.MainMessageHub = MainMessageHub;
