"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RendererMessageHub = void 0;
const electron_1 = __importDefault(require("electron"));
const abstract_1 = require("./abstract");
let rendererMessageHub;
class RendererMessageHub extends abstract_1.ElectronMessageHub {
    constructor(options) {
        if (process.type !== 'renderer') {
            throw new TypeError('RendererMessageHub only available in main renderer process');
        }
        super(options);
        this._ipc = electron_1.default.ipcRenderer;
        this._ipc.on(this._channelName, this._onMessageReceived);
    }
    emit(method, ...args) {
        return super._emit(this._ipc, method, ...args);
    }
    on(handlerMap, handler) {
        // @ts-ignore
        this._on(this._ipc, handlerMap, handler);
    }
    off(methodName) {
        this._off(this._ipc, methodName);
    }
    /** shared MainMessageHub instance */
    static get shared() {
        if (!rendererMessageHub) {
            rendererMessageHub = new RendererMessageHub();
        }
        return rendererMessageHub;
    }
}
exports.RendererMessageHub = RendererMessageHub;
